// Watchdog.cpp

#include "stdafx.h"

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	bool * pFound = (bool *)lParam;
	*pFound = true;
	return FALSE;
}

bool IsInputDesktopEmpty()
{
	HDESK hdesk = OpenInputDesktop(0, FALSE, DESKTOP_READOBJECTS);
	if (hdesk == NULL)
	{
		// This almost always means the Winlogon desktop is active.
		return false;
	}

	bool found = false;
	EnumDesktopWindows(hdesk, EnumWindowsProc, (LPARAM)&found);

	CloseDesktop(hdesk);

	return !found;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	while (true)
	{
		if (!IsInputDesktopEmpty())
		{
			Sleep(10000);
		}
		else
		{
			// Wait 2 secs and test again, just to be sure.
			Sleep(2000);
			if (!IsInputDesktopEmpty())
				continue;

			// Try switching to the watchdog's desktop.
			HDESK hdeskMine = GetThreadDesktop(GetCurrentThreadId());
			SwitchDesktop(hdeskMine);

			// Backup plan:  switch to the default desktop.
			if (IsInputDesktopEmpty())
			{
				HDESK hdeskDefault = OpenDesktop(
					TEXT("Default"),
					0,
					FALSE,
					DESKTOP_SWITCHDESKTOP);
				SwitchDesktop(hdeskDefault);
				CloseDesktop(hdeskDefault);
			}
		}
	}
	return 0;
}